import LRUCache, { Options } from 'lru-cache';
import { Config, Cache, Store } from '../caching';
declare type Lru = LRUCache<string, unknown>;
export declare type MemoryConfig = {
    max?: number;
    sizeCalculation?: (key: string, value: unknown) => number;
    shouldCloneBeforeSet?: boolean;
} & Options<string, unknown> & Config;
export declare type MemoryStore = Store & {
    keyCount: () => number;
    dump: Lru['dump'];
    load: Lru['load'];
};
export declare type MemoryCache = Cache<MemoryStore>;
/**
 * Wrapper for lru-cache.
 */
export declare function memoryStore(args?: MemoryConfig): MemoryStore;
export {};
